<template>
	<el-row class="table">
		<el-table
			:data="tableData"
			style="width: 100%"
			align="center"
			@selection-change="handleSelectionChange"
		>
			<el-table-column
				v-if="filter_conf.otherColumn && filter_conf.otherColumn['selection']"
				type="selection"
				width="55"
			></el-table-column>
			<el-table-column
				v-if="filter_conf.otherColumn && filter_conf.otherColumn['index']"
				type="index"
				width="50"
			></el-table-column>
			<el-table-column
				class="head"
				v-for="(head,index) in filter_conf.headers"
				:key="index"
				:border="true"
				:prop="head.prop"
				:label="head.label"
				:width="head.width"
			>
				<template slot-scope="scope">
					<el-row v-if="head.type === 'upload'">
						<ootecoUpload :conf="uploadParams(head,scope)"></ootecoUpload>
					</el-row>
					<el-row v-else-if="head.type === 'select'">
						<el-radio v-model="filter_conf.radio" :label="scope.row[head.prop]"></el-radio>
					</el-row>
					<el-row v-else-if="head.type === 'textButton'" class="flexHcenter">
						<div class="cusorSpan" v-for="(button,btn_index) in head.buttons" :key="btn_index">
							<ootecoUpload
								v-if="button.type && button.type === 'upload'"
								v-show="!scope.row.checkStatusName"
								:conf="uploadParams(button,scope)"
							></ootecoUpload>
							<span
								v-else
								v-show="!scope.row.checkStatusName || btn_index !== 0"
								@click="btn_click(scope,button)"
							>&nbsp;{{(btn_index > 0 && !scope.row.checkStatusName) ? '|' : ''}}&nbsp;{{button.text}}</span>
						</div>
						<div
							class="cusorSpan"
							v-for="(val,key) in scope.row[head.prop]"
							v-if="val && val.length"
							:key="key"
							@click.stop="showDatasDialog(proveDataType(key),val,scope.row)"
						>&nbsp;{{proveDataType(key)}}</div>
					</el-row>
					<el-row v-else-if="head.type === 'download'">
						<ootecoDownload :conf="scope.row"></ootecoDownload>
					</el-row>
					<el-row v-else-if="head.type === 'badge'">
						<img
							v-if="scope.row.readStatus === 1"
							src="../assets/img/1031542297622_.pic_hd.jpg"
							style="width:auto;height:1rem;vertical-align: middle;margin-top:-2.5px;"
							alt=""
						>
						<span>{{head.filter ? head.filter(scope.row[head.prop]) : scope.row[head.prop]}}</span>
					</el-row>
					<el-row v-else-if="head.type === 'textOrButton' && !scope.row[head.prop]">
						<el-button
							type="primary"
							size="mini"
							v-if="$route.query.businessId"
							v-for="(btn,btn_index) in head.buttons"
							:key="btn_index"
							plain
							@click="btn_click(scope,btn)"
						>提交审核</el-button>
					</el-row>
					<el-row v-else-if="head.type === 'button'">
						<el-button
							size="mini"
							v-for="(btn,idx) in head.sub_conf"
							v-if="btn.show(scope.row)"
							:key="idx"
							:type="btn.type"
							@click="btn_click(scope,btn)"
						>{{btn.text}}</el-button>
					</el-row>
					<el-row v-else-if="head.type === 'important'">
						<span v-if="scope.row.type === 1" style="color:red;">**</span>
						{{head.filter ? head.filter(scope.row[head.prop]) : scope.row[head.prop]}}
					</el-row>
					<el-row
						v-else
						:style="head.style"
					>{{head.filter ? head.filter(scope.row[head.prop]) : scope.row[head.prop]}}</el-row>
				</template>
			</el-table-column>
		</el-table>
		<el-pagination
			v-if="pagination && pagination.type === 1"
			class="marginTop20 marginBottom40"
			background=""
			layout="slot"
			:total="1000"
		>
			<slot>
				<el-row class="pagenation definePagenation">
					<button @click="pageNum = 1">首页</button>
					<button @click="pageNum == 1 ? null : pageNum--">上一页</button>
					<button @click="pageNum == countPage ? null : pageNum++">下一页</button>
					<button @click="pageNum = countPage">尾页</button>
				</el-row>
			</slot>
		</el-pagination>
		<el-pagination
			v-else-if="pagination"
			class="pagination"
			@size-change="handleSizeChange"
			@current-change="handleCurrentChange"
			:current-page="currentPage"
			:page-sizes="[20, 30, 40, 50]"
			:page-size="100"
			layout="total, sizes, prev, pager, next, jumper"
			:total="400"
		></el-pagination>
	</el-row>
</template>

<script>
import ootecoUpload from '@com/ooteco_upload'
import ootecoDownload from '@com/ooteco_download_file'
export default {
	mixins: [$mixin],
	props: ['conf', 'url'],
	components: { ootecoUpload, ootecoDownload },
	data() {
		return {
			isFirst: false,
			currentPage: 0,
			countPage: 0,
			pageNum: 1,
			pageSize: 10,
			proveDatas: [
				{
					value: 'orders',
					label: '订单'
				},
				{
					value: 'deliveryNotes',
					label: '送货单'
				},
				{
					value: 'receiptNotes',
					label: '签收单'
				},
				{
					value: 'accountStatements',
					label: '对账单'
				},
				{
					value: 'qualityInspections',
					label: '质检证明'
				},
				{
					value: 'others',
					label: '其它'
				}
			]
		}
	},
	computed: {
		filter_conf() {
			//let headers = this.conf.headers.filter(item => {
				//return typeof item.show === 'undefined' || item.show === true
			//})
			//this.$set(this.conf, "headers", headers)
			return this.conf || {}
		},
		tableData() {
			return this.filter_conf.data || []
		},
		params() {
			return this.filter_conf.params
		},
		pagination() {
			return this.filter_conf.pagination
		}
	},
	watch: {
		params(val) {
			// this.requestData()
		},
		pageNum() {
            this.$set(this.params, 'pageNum', this.pageNum)
            this.requestData()
		},
		pageSize() {
            this.$set(this.params, 'pageSize', this.pageSize)
			this.requestData()
		}
	},
	methods: {
		proveDataType(key) {
			let arr = this.proveDatas.filter(item => {
				return item.value === key
			})
			return arr.length ? arr[0].label : ''
		},
		showDatasDialog(title, val, scope) {
			console.log(val)
			$event_bus.$emit('showDatasDialogAction', { title, val, scope })
		},
		handleSelectionChange(val) {
			$event_bus.$emit('handleSelectionChange', val)
		},
		uploadParams(head, scope) {
			return Object.assign(
				{},
				scope,
				{
					data: {
						attachmentInfoId: scope.row.attachmentInfoId,
						companyId: this.userInfo.companyId
					}
				},
				head.sub_conf
			)
		},
		btn_click(scope, btn) {
			if (typeof btn.event === 'function') {
				btn.event(scope)
			} else if (typeof btn.event === 'string') {
				$event_bus.$emit(btn.event, scope)
			}
		},
		handleSizeChange(val) {
			this.$set(this.params, 'pageSize', val)
			this.requestData()
		},
		handleCurrentChange(val) {
			this.$set(this.params, 'pageNum', val)
			this.requestData()
		},
		requestData() {
			if (!this.url) return false
			if(this.params.pageSize){
			    this.pageSize = this.params.pageSize
			}
            if(this.params.pageNum){
                this.pageNum = this.params.pageNum
            }
			this.$http
				.get({
					url: this.url,
					/*params: Object.assign(
						{},
						{
							pageNum: this.pageNum,
							pageSize: this.pageSize
						},
						utils.deepClone(this.params)
					)*/
					params: this.params
				})
				.then(
					({ data }) => {
					    this.countPage = data.pages || 0
						data = data.list || data
						data.forEach((item, index) => {
							this.$set(item, 'radio', index)
						})
						this.$set(this.filter_conf, 'data', data)
					},
					msg => {
						this.alert(msg)
					}
				)
		}
	},
	mounted() {
		this.url && this.requestData()
	}
}
</script>

<style lang="less">
.table {
	.pagination {
		text-align: right;
		margin-top: 1.25rem;
	}
	.cell {
		text-align: center;
	}
	th {
		border-left: 0.0625rem solid #efeef5;
		border-top: 0.0625rem solid #efeef5;
	}
	th:last-child {
		border-right: 0.0625rem solid #efeef5;
	}
}
span.el-table__empty-text {
	text-align: center;
}
tr.el-table__row {
	td {
		border-left: 0.0625rem solid #efeef5;
	}
	td:last-child {
		border-right: 0.0625rem solid #efeef5;
	}
}
.definePagenation {
	display: flex;
	justify-content: flex-end;
	button {
		display: inline-block;
		margin-left: 0.625rem;
		width: 3.75rem;
		height: 1.625rem;
		border-radius: 0.812rem;
		line-height: 1.625rem;
		color: #999;
		text-align: center;
		border: 0.0625rem solid #dddddd;
	}
	button:hover {
		border: 0.0625rem solid #3990e9;
	}
	button:first-child {
		margin-left: 0;
	}
}
.cusorSpan {
	display: inline-block;
	cursor: pointer;
	color: #3990e9;
}
</style>
